diff -ur --unidirectional-new-file /usr/src/usr.sbin/inetd/inetd.c /usr/src-new/usr.sbin/inetd/inetd.c
--- /usr/src/usr.sbin/inetd/inetd.c	2006-01-13 14:26:46.000000000 -0600
+++ /usr/src-new/usr.sbin/inetd/inetd.c	2006-06-20 11:11:04.000000000 -0500
@@ -1656,286 +1394,278 @@
 		sep->se_socktype = -1;
 
 	arg = sskip(&cp);
-	if (strncmp(arg, "tcp", 3) == 0) {
-		sep->se_proto = newstr(strsep(&arg, "/"));
-		if (arg != NULL) {
-			if (strcmp(arg, "ttcp") == 0)
-				sep->se_type = TTCP_TYPE;
-			else if (strcmp(arg, "faith") == 0)
-				sep->se_type = FAITH_TYPE;
-		}
-	} else {
-		if (sep->se_type == NORM_TYPE &&
-		    strncmp(arg, "faith/", 6) == 0) {
-			arg += 6;
-			sep->se_type = FAITH_TYPE;
-		}
-		sep->se_proto = newstr(arg);
-	}
-        if (strncmp(sep->se_proto, "rpc/", 4) == 0) {
-		if (no_v4bind != 0) {
-			syslog(LOG_NOTICE, "IPv4 bind is ignored for %s",
-			       sep->se_service);
-			freeconfig(sep);
+	if (sep->se_type == NORM_TYPE &&
+	    strncmp(arg, "faith/", strlen("faith/")) == 0) {
+		arg += strlen("faith/");
+		sep->se_type = FAITH_TYPE;
+	}
+	sep->se_proto = newstr(arg);
+
+#define	MALFORMED(arg) \
+do { \
+	syslog(LOG_ERR, "%s: malformed buffer size option `%s'", \
+	    sep->se_service, (arg)); \
+	goto more; \
+} while (0)
+
+#define	GETVAL(arg) \
+do { \
+	if (!isdigit((unsigned char)*(arg))) \
+		MALFORMED(arg); \
+	val = strtol((arg), &cp0, 10); \
+	if (cp0 != NULL) { \
+		if (cp0[1] != '\0') \
+			MALFORMED((arg)); \
+		if (cp0[0] == 'k') \
+			val *= 1024; \
+		if (cp0[0] == 'm') \
+			val *= 1024 * 1024; \
+	} \
+	if (val < 1) { \
+		syslog(LOG_ERR, "%s: invalid buffer size `%s'", \
+		    sep->se_service, (arg)); \
+		goto more; \
+	} \
+} while (0)
+
+#define	ASSIGN(arg) \
+do { \
+	if (strcmp((arg), "sndbuf") == 0) \
+		sep->se_sndbuf = val; \
+	else if (strcmp((arg), "rcvbuf") == 0) \
+		sep->se_rcvbuf = val; \
+	else \
+		MALFORMED((arg)); \
+} while (0)
+
+	/*
+	 * Extract the send and receive buffer sizes before parsing
+	 * the protocol.
+	 */
+	sep->se_sndbuf = sep->se_rcvbuf = 0;
+	buf0 = buf1 = sz0 = sz1 = NULL;
+	if ((buf0 = strchr(sep->se_proto, ',')) != NULL) {
+		/* Not meaningful for Tcpmux services. */
+		if (ISMUX(sep)) {
+			syslog(LOG_ERR, "%s: can't specify buffer sizes for "
+			    "tcpmux services", sep->se_service);
 			goto more;
 		}
-                memmove(sep->se_proto, sep->se_proto + 4,
-                    strlen(sep->se_proto) + 1 - 4);
-                sep->se_rpc = 1;
-                sep->se_rpc_prog = sep->se_rpc_lowvers =
-			sep->se_rpc_lowvers = 0;
-		memcpy(&sep->se_ctrladdr4, bind_sa4,
-		       sizeof(sep->se_ctrladdr4));
-                if ((versp = strrchr(sep->se_service, '/'))) {
-                        *versp++ = '\0';
-                        switch (sscanf(versp, "%u-%u",
-                                       &sep->se_rpc_lowvers,
-                                       &sep->se_rpc_highvers)) {
-                        case 2:
-                                break;
-                        case 1:
-                                sep->se_rpc_highvers =
-                                        sep->se_rpc_lowvers;
-                                break;
-                        default:
-                                syslog(LOG_ERR,
-					"bad RPC version specifier; %s",
-					sep->se_service);
-                                freeconfig(sep);
-                                goto more;
-                        }
-                }
-                else {
-                        sep->se_rpc_lowvers =
-                                sep->se_rpc_highvers = 1;
-                }
-        }
-	sep->se_nomapped = 0;
-	while (isdigit(sep->se_proto[strlen(sep->se_proto) - 1])) {
-#ifdef INET6
-		if (sep->se_proto[strlen(sep->se_proto) - 1] == '6') {
-			if (no_v6bind != 0) {
-				syslog(LOG_NOTICE, "IPv6 bind is ignored for %s",
-				       sep->se_service);
-				freeconfig(sep);
+
+		/* Skip the , */
+		*buf0++ = '\0';
+
+		/* Check to see if another socket buffer size was specified. */
+		if ((buf1 = strchr(buf0, ',')) != NULL) {
+			/* Skip the , */
+			*buf1++ = '\0';
+
+			/* Make sure a 3rd one wasn't specified. */
+			if (strchr(buf1, ',') != NULL) {
+				syslog(LOG_ERR, "%s: too many buffer sizes",
+				    sep->se_service);
 				goto more;
 			}
-			sep->se_proto[strlen(sep->se_proto) - 1] = '\0';
-			v6bind = 1;
-			continue;
+
+			/* Locate the size. */
+			if ((sz1 = strchr(buf1, '=')) == NULL)
+				MALFORMED(buf1);
+
+			/* Skip the = */
+			*sz1++ = '\0';
 		}
-#endif
-		if (sep->se_proto[strlen(sep->se_proto) - 1] == '4') {
-			sep->se_proto[strlen(sep->se_proto) - 1] = '\0';
-			v4bind = 1;
-			continue;
+
+		/* Locate the size. */
+		if ((sz0 = strchr(buf0, '=')) == NULL)
+			MALFORMED(buf0);
+
+		/* Skip the = */
+		*sz0++ = '\0';
+
+		GETVAL(sz0);
+		ASSIGN(buf0);
+
+		if (buf1 != NULL) {
+			GETVAL(sz1);
+			ASSIGN(buf1);
 		}
-		/* illegal version num */
-		syslog(LOG_ERR,	"bad IP version for %s", sep->se_proto);
-		freeconfig(sep);
-		goto more;
 	}
+
+#undef ASSIGN
+#undef GETVAL
+#undef MALFORMED
+
 	if (strcmp(sep->se_proto, "unix") == 0) {
-	        sep->se_family = AF_UNIX;
-	} else
-#ifdef INET6
-	if (v6bind != 0) {
-		sep->se_family = AF_INET6;
-		if (v4bind == 0 || no_v4bind != 0)
-			sep->se_nomapped = 1;
-	} else
-#endif
-	{ /* default to v4 bind if not v6 bind */
-		if (no_v4bind != 0) {
-			syslog(LOG_NOTICE, "IPv4 bind is ignored for %s",
-			       sep->se_service);
-			freeconfig(sep);
+		sep->se_family = AF_LOCAL;
+	} else {
+		val = strlen(sep->se_proto);
+		if (!val) {
+			syslog(LOG_ERR, "%s: invalid protocol specified",
+			    sep->se_service);
 			goto more;
 		}
-		sep->se_family = AF_INET;
-	}
-	/* init ctladdr */
-	switch(sep->se_family) {
-	case AF_INET:
-		memcpy(&sep->se_ctrladdr4, bind_sa4,
-		       sizeof(sep->se_ctrladdr4));
-		sep->se_ctrladdr_size =	sizeof(sep->se_ctrladdr4);
-		break;
+		val = sep->se_proto[val - 1];
+		switch (val) {
+		case '4':	/*tcp4 or udp4*/
+			sep->se_family = AF_INET;
+			break;
 #ifdef INET6
-	case AF_INET6:
-		memcpy(&sep->se_ctrladdr6, bind_sa6,
-		       sizeof(sep->se_ctrladdr6));
-		sep->se_ctrladdr_size =	sizeof(sep->se_ctrladdr6);
-		break;
+		case '6':	/*tcp6 or udp6*/
+			sep->se_family = AF_INET6;
+			break;
 #endif
-	case AF_UNIX:
-		if (strlen(sep->se_service) >= sizeof(sep->se_ctrladdr_un.sun_path)) {
-			syslog(LOG_ERR, 
-			    "domain socket pathname too long for service %s",
+		default:
+			sep->se_family = AF_INET;	/*will become AF_INET6*/
+			break;
+		}
+		if (strncmp(sep->se_proto, "rpc/", 4) == 0) {
+#ifdef RPC
+			char *cp, *ccp;
+			cp = strchr(sep->se_service, '/');
+			if (cp == 0) {
+				syslog(LOG_ERR, "%s: no rpc version",
+				    sep->se_service);
+				goto more;
+			}
+			*cp++ = '\0';
+			sep->se_rpcversl = sep->se_rpcversh =
+			    strtol(cp, &ccp, 0);
+			if (ccp == cp) {
+		badafterall:
+				syslog(LOG_ERR, "%s/%s: bad rpc version",
+				    sep->se_service, cp);
+				goto more;
+			}
+			if (*ccp == '-') {
+				cp = ccp + 1;
+				sep->se_rpcversh = strtol(cp, &ccp, 0);
+				if (ccp == cp)
+					goto badafterall;
+			}
+#else
+			syslog(LOG_ERR, "%s: rpc services not suported",
 			    sep->se_service);
 			goto more;
+#endif /* RPC */
 		}
-		memset(&sep->se_ctrladdr, 0, sizeof(sep->se_ctrladdr));
-		sep->se_ctrladdr_un.sun_family = sep->se_family;
-		sep->se_ctrladdr_un.sun_len = strlen(sep->se_service);
-		strcpy(sep->se_ctrladdr_un.sun_path, sep->se_service);
-		sep->se_ctrladdr_size = SUN_LEN(&sep->se_ctrladdr_un);
 	}
 	arg = sskip(&cp);
-	if (!strncmp(arg, "wait", 4))
-		sep->se_accept = 0;
-	else if (!strncmp(arg, "nowait", 6))
-		sep->se_accept = 1;
-	else {
-		syslog(LOG_ERR,
-			"%s: bad wait/nowait for service %s",
-			CONFIG, sep->se_service);
-		goto more;
-	}
-	sep->se_maxchild = -1;
-	sep->se_maxcpm = -1;
-	sep->se_maxperip = -1;
-	if ((s = strchr(arg, '/')) != NULL) {
-		char *eptr;
-		u_long val;
-
-		val = strtoul(s + 1, &eptr, 10);
-		if (eptr == s + 1 || val > MAX_MAXCHLD) {
-			syslog(LOG_ERR,
-				"%s: bad max-child for service %s",
-				CONFIG, sep->se_service);
-			goto more;
-		}
-		if (debug)
-			if (!sep->se_accept && val != 1)
-				warnx("maxchild=%lu for wait service %s"
-				    " not recommended", val, sep->se_service);
-		sep->se_maxchild = val;
-		if (*eptr == '/')
-			sep->se_maxcpm = strtol(eptr + 1, &eptr, 10);
-		if (*eptr == '/')
-			sep->se_maxperip = strtol(eptr + 1, &eptr, 10);
-		/*
-		 * explicitly do not check for \0 for future expansion /
-		 * backwards compatibility
-		 */
+	{
+		char *cp;
+		if ((cp = strchr(arg, ':')) == NULL)
+			cp = strchr(arg, '.');
+		if (cp != NULL) {
+			*cp++ = '\0';
+			sep->se_max = atoi(cp);
+		} else
+			sep->se_max = TOOMANY;
 	}
+	sep->se_wait = strcmp(arg, "wait") == 0;
 	if (ISMUX(sep)) {
 		/*
-		 * Silently enforce "nowait" mode for TCPMUX services
-		 * since they don't have an assigned port to listen on.
+		 * Silently enforce "nowait" for TCPMUX services since
+		 * they don't have an assigned port to listen on.
 		 */
-		sep->se_accept = 1;
-		if (strcmp(sep->se_proto, "tcp")) {
-			syslog(LOG_ERR,
-				"%s: bad protocol for tcpmux service %s",
-				CONFIG, sep->se_service);
+		sep->se_wait = 0;
+
+		if (strncmp(sep->se_proto, "tcp", 3)) {
+			syslog(LOG_ERR, 
+			    "%s: bad protocol for tcpmux service %s",
+			    CONFIG, sep->se_service);
 			goto more;
 		}
 		if (sep->se_socktype != SOCK_STREAM) {
-			syslog(LOG_ERR,
-				"%s: bad socket type for tcpmux service %s",
-				CONFIG, sep->se_service);
+			syslog(LOG_ERR, 
+			    "%s: bad socket type for tcpmux service %s",
+			    CONFIG, sep->se_service);
 			goto more;
 		}
 	}
 	sep->se_user = newstr(sskip(&cp));
-#ifdef LOGIN_CAP
-	if ((s = strrchr(sep->se_user, '/')) != NULL) {
-		*s = '\0';
-		sep->se_class = newstr(s + 1);
-	} else
-		sep->se_class = newstr(RESOURCE_RC);
-#endif
-	if ((s = strrchr(sep->se_user, ':')) != NULL) {
-		*s = '\0';
-		sep->se_group = newstr(s + 1);
-	} else
-		sep->se_group = NULL;
+	if ((sep->se_group = strchr(sep->se_user, ':')) != NULL)
+		*sep->se_group++ = '\0';
+	else if ((sep->se_group = strchr(sep->se_user, '.')) != NULL)
+		*sep->se_group++ = '\0';
+
 	sep->se_server = newstr(sskip(&cp));
-	if ((sep->se_server_name = strrchr(sep->se_server, '/')))
-		sep->se_server_name++;
 	if (strcmp(sep->se_server, "internal") == 0) {
 		struct biltin *bi;
 
 		for (bi = biltins; bi->bi_service; bi++)
 			if (bi->bi_socktype == sep->se_socktype &&
-			    matchservent(bi->bi_service, sep->se_service,
-			    sep->se_proto))
+			    strcmp(bi->bi_service, sep->se_service) == 0)
 				break;
 		if (bi->bi_service == 0) {
 			syslog(LOG_ERR, "internal service %s unknown",
-				sep->se_service);
+			    sep->se_service);
 			goto more;
 		}
-		sep->se_accept = 1;	/* force accept mode for built-ins */
 		sep->se_bi = bi;
+		sep->se_wait = bi->bi_wait;
 	} else
 		sep->se_bi = NULL;
-	if (sep->se_maxperip < 0)
-		sep->se_maxperip = maxperip;
-	if (sep->se_maxcpm < 0)
-		sep->se_maxcpm = maxcpm;
-	if (sep->se_maxchild < 0) {	/* apply default max-children */
-		if (sep->se_bi && sep->se_bi->bi_maxchild >= 0)
-			sep->se_maxchild = sep->se_bi->bi_maxchild;
-		else if (sep->se_accept) 
-			sep->se_maxchild = maxchild > 0 ? maxchild : 0;
-		else
-			sep->se_maxchild = 1;
-	}
-	if (sep->se_maxchild > 0) {
-		sep->se_pids = malloc(sep->se_maxchild * sizeof(*sep->se_pids));
-		if (sep->se_pids == NULL) {
-			syslog(LOG_ERR, "malloc: %m");
-			exit(EX_OSERR);
-		}
-	}
 	argc = 0;
-	for (arg = skip(&cp); cp; arg = skip(&cp))
-		if (argc < MAXARGV) {
-			sep->se_argv[argc++] = newstr(arg);
-		} else {
-			syslog(LOG_ERR,
-				"%s: too many arguments for service %s",
-				CONFIG, sep->se_service);
-			goto more;
+	for (arg = skip(&cp); cp; arg = skip(&cp)) {
+#if MULOG
+		char *colon;
+
+		if (argc == 0 && (colon = strrchr(arg, ':'))) {
+			while (arg < colon) {
+				int	x;
+				char	*ccp;
+
+				switch (*arg++) {
+				case 'l':
+					x = 1;
+					if (isdigit(*arg)) {
+						x = strtol(arg, &ccp, 0);
+						if (ccp == arg)
+							break;
+						arg = ccp;
+					}
+					sep->se_log &= ~MULOG_RFC931;
+					sep->se_log |= x;
+					break;
+				case 'a':
+					sep->se_log |= MULOG_RFC931;
+					break;
+				default:
+					break;
+				}
+			}
+			arg = colon + 1;
 		}
+#endif
+		if (argc < MAXARGV)
+			sep->se_argv[argc++] = newstr(arg);
+	}
 	while (argc <= MAXARGV)
 		sep->se_argv[argc++] = NULL;
-	for (i = 0; i < PERIPSIZE; ++i)
-		LIST_INIT(&sep->se_conn[i]);
 #ifdef IPSEC
 	sep->se_policy = policy ? newstr(policy) : NULL;
 #endif
 	return (sep);
 }
 
-void
+static void
 freeconfig(struct servtab *cp)
 {
 	int i;
 
+	if (cp->se_hostaddr)
+		free(cp->se_hostaddr);
 	if (cp->se_service)
 		free(cp->se_service);
 	if (cp->se_proto)
 		free(cp->se_proto);
 	if (cp->se_user)
 		free(cp->se_user);
-	if (cp->se_group)
-		free(cp->se_group);
-#ifdef LOGIN_CAP
-	if (cp->se_class)
-		free(cp->se_class);
-#endif
+	/* Note: se_group is part of the newstr'ed se_user */
 	if (cp->se_server)
 		free(cp->se_server);
-	if (cp->se_pids)
-		free(cp->se_pids);
 	for (i = 0; i < MAXARGV; i++)
 		if (cp->se_argv[i])
 			free(cp->se_argv[i]);
-	free_connlist(cp);
 #ifdef IPSEC
 	if (cp->se_policy)
 		free(cp->se_policy);
@@ -1947,7 +1677,7 @@
  * Safe skip - if skip returns null, log a syntax error in the
  * configuration file and exit.
  */
-char *
+static char *
 sskip(char **cpp)
 {
 	char *cp;
@@ -1955,17 +1685,20 @@
 	cp = skip(cpp);
 	if (cp == NULL) {
 		syslog(LOG_ERR, "%s: syntax error", CONFIG);
-		exit(EX_DATAERR);
+		exit(1);
 	}
 	return (cp);
 }
 
-char *
+static char *
 skip(char **cpp)
 {
 	char *cp = *cpp;
 	char *start;
-	char quote = '\0';
+	char quote;
+
+	if (*cpp == NULL)
+		return (NULL);
 
 again:
 	while (*cp == ' ' || *cp == '\t')
